/* CertButton.c generated by valac 0.38.10, the Vala compiler
 * generated from CertButton.vala, do not modify */

/*
* Copyright (c) 2016-2017 elementary LLC (http://launchpad.net/capnet-assist)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 2 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA.
*
*/

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <pango/pango.h>
#include <gcr/gcr-base.h>
#include <ui/gcr-ui.h>
#include <gdk/gdk.h>
#include <cairo.h>
#include <float.h>
#include <math.h>
#include <glib/gi18n-lib.h>


#define TYPE_CERT_BUTTON (cert_button_get_type ())
#define CERT_BUTTON(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CERT_BUTTON, CertButton))
#define CERT_BUTTON_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CERT_BUTTON, CertButtonClass))
#define IS_CERT_BUTTON(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CERT_BUTTON))
#define IS_CERT_BUTTON_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CERT_BUTTON))
#define CERT_BUTTON_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CERT_BUTTON, CertButtonClass))

typedef struct _CertButton CertButton;
typedef struct _CertButtonClass CertButtonClass;
typedef struct _CertButtonPrivate CertButtonPrivate;

#define CERT_BUTTON_TYPE_SECURITY (cert_button_security_get_type ())

#define TYPE_CAPTIVE_LOGIN (captive_login_get_type ())
#define CAPTIVE_LOGIN(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CAPTIVE_LOGIN, CaptiveLogin))
#define CAPTIVE_LOGIN_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CAPTIVE_LOGIN, CaptiveLoginClass))
#define IS_CAPTIVE_LOGIN(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CAPTIVE_LOGIN))
#define IS_CAPTIVE_LOGIN_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CAPTIVE_LOGIN))
#define CAPTIVE_LOGIN_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CAPTIVE_LOGIN, CaptiveLoginClass))

typedef struct _CaptiveLogin CaptiveLogin;
typedef struct _CaptiveLoginClass CaptiveLoginClass;
enum  {
	CERT_BUTTON_0_PROPERTY,
	CERT_BUTTON_SECURITY_PROPERTY,
	CERT_BUTTON_CAPTIVE_LOGIN_WINDOW_PROPERTY,
	CERT_BUTTON_NUM_PROPERTIES
};
static GParamSpec* cert_button_properties[CERT_BUTTON_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block2Data Block2Data;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_byte_array_unref0(var) ((var == NULL) ? NULL : (var = (g_byte_array_unref (var), NULL)))

struct _CertButton {
	GtkToggleButton parent_instance;
	CertButtonPrivate * priv;
};

struct _CertButtonClass {
	GtkToggleButtonClass parent_class;
};

typedef enum  {
	CERT_BUTTON_SECURITY_NONE,
	CERT_BUTTON_SECURITY_SECURE,
	CERT_BUTTON_SECURITY_LOADING,
	CERT_BUTTON_SECURITY_MIXED_CONTENT
} CertButtonSecurity;

struct _CertButtonPrivate {
	CertButtonSecurity _security;
	CaptiveLogin* _captive_login_window;
};

struct _Block2Data {
	int _ref_count_;
	CertButton* self;
	GtkPopover* popover;
};


static gpointer cert_button_parent_class = NULL;

GType cert_button_get_type (void) G_GNUC_CONST;
GType cert_button_security_get_type (void) G_GNUC_CONST;
GType captive_login_get_type (void) G_GNUC_CONST;
#define CERT_BUTTON_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_CERT_BUTTON, CertButtonPrivate))
CertButton* cert_button_new (CaptiveLogin* captive_login_window);
CertButton* cert_button_construct (GType object_type, CaptiveLogin* captive_login_window);
static void cert_button_on_tls_button_click (CertButton* self);
static Block2Data* block2_data_ref (Block2Data* _data2_);
static void block2_data_unref (void * _userdata_);
CaptiveLogin* cert_button_get_captive_login_window (CertButton* self);
gboolean captive_login_get_tls_info (CaptiveLogin* self, GTlsCertificate* * certificate, GTlsCertificateFlags* errors);
gchar* captive_login_get_uri (CaptiveLogin* self);
CertButtonSecurity cert_button_get_security (CertButton* self);
static gboolean __lambda7_ (CertButton* self, GdkEventButton* event);
static gboolean ___lambda7__gtk_widget_button_press_event (GtkWidget* _sender, GdkEventButton* event, gpointer self);
static gboolean __lambda8_ (Block2Data* _data2_, GdkEventButton* event);
static gboolean ___lambda8__gtk_widget_button_release_event (GtkWidget* _sender, GdkEventButton* event, gpointer self);
void cert_button_set_security (CertButton* self, CertButtonSecurity value);
void cert_button_set_captive_login_window (CertButton* self, CaptiveLogin* value);
static GObject * cert_button_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties);
static void _cert_button_on_tls_button_click_gtk_toggle_button_toggled (GtkToggleButton* _sender, gpointer self);
static void cert_button_finalize (GObject * obj);
static void _vala_cert_button_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_cert_button_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);


GType cert_button_security_get_type (void) {
	static volatile gsize cert_button_security_type_id__volatile = 0;
	if (g_once_init_enter (&cert_button_security_type_id__volatile)) {
		static const GEnumValue values[] = {{CERT_BUTTON_SECURITY_NONE, "CERT_BUTTON_SECURITY_NONE", "none"}, {CERT_BUTTON_SECURITY_SECURE, "CERT_BUTTON_SECURITY_SECURE", "secure"}, {CERT_BUTTON_SECURITY_LOADING, "CERT_BUTTON_SECURITY_LOADING", "loading"}, {CERT_BUTTON_SECURITY_MIXED_CONTENT, "CERT_BUTTON_SECURITY_MIXED_CONTENT", "mixed-content"}, {0, NULL, NULL}};
		GType cert_button_security_type_id;
		cert_button_security_type_id = g_enum_register_static ("CertButtonSecurity", values);
		g_once_init_leave (&cert_button_security_type_id__volatile, cert_button_security_type_id);
	}
	return cert_button_security_type_id__volatile;
}


CertButton* cert_button_construct (GType object_type, CaptiveLogin* captive_login_window) {
	CertButton * self = NULL;
	CaptiveLogin* _tmp0_;
	g_return_val_if_fail (captive_login_window != NULL, NULL);
	_tmp0_ = captive_login_window;
	self = (CertButton*) g_object_new (object_type, "security", CERT_BUTTON_SECURITY_LOADING, "captive-login-window", _tmp0_, NULL);
	return self;
}


CertButton* cert_button_new (CaptiveLogin* captive_login_window) {
	return cert_button_construct (TYPE_CERT_BUTTON, captive_login_window);
}


static Block2Data* block2_data_ref (Block2Data* _data2_) {
	g_atomic_int_inc (&_data2_->_ref_count_);
	return _data2_;
}


static void block2_data_unref (void * _userdata_) {
	Block2Data* _data2_;
	_data2_ = (Block2Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data2_->_ref_count_)) {
		CertButton* self;
		self = _data2_->self;
		_g_object_unref0 (_data2_->popover);
		_g_object_unref0 (self);
		g_slice_free (Block2Data, _data2_);
	}
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


static gboolean __lambda7_ (CertButton* self, GdkEventButton* event) {
	gboolean result = FALSE;
	g_return_val_if_fail (event != NULL, FALSE);
	result = TRUE;
	return result;
}


static gboolean ___lambda7__gtk_widget_button_press_event (GtkWidget* _sender, GdkEventButton* event, gpointer self) {
	gboolean result;
	result = __lambda7_ ((CertButton*) self, event);
	return result;
}


static gboolean __lambda8_ (Block2Data* _data2_, GdkEventButton* event) {
	CertButton* self;
	gboolean result = FALSE;
	GtkWidget* child = NULL;
	GtkPopover* _tmp0_;
	GtkWidget* _tmp1_;
	GtkWidget* _tmp2_;
	GtkWidget* event_widget = NULL;
	GdkEventButton* _tmp3_;
	GtkWidget* _tmp4_;
	GtkWidget* _tmp5_;
	gboolean _tmp6_ = FALSE;
	GtkWidget* _tmp7_;
	self = _data2_->self;
	g_return_val_if_fail (event != NULL, FALSE);
	_tmp0_ = _data2_->popover;
	_tmp1_ = gtk_bin_get_child ((GtkBin*) _tmp0_);
	_tmp2_ = _g_object_ref0 (_tmp1_);
	child = _tmp2_;
	_tmp3_ = event;
	_tmp4_ = gtk_get_event_widget ((GdkEvent*) _tmp3_);
	_tmp5_ = _g_object_ref0 (_tmp4_);
	event_widget = _tmp5_;
	_tmp7_ = child;
	if (_tmp7_ != NULL) {
		GdkEventButton* _tmp8_;
		GdkWindow* _tmp9_;
		GtkPopover* _tmp10_;
		GdkWindow* _tmp11_;
		_tmp8_ = event;
		_tmp9_ = _tmp8_->window;
		_tmp10_ = _data2_->popover;
		_tmp11_ = gtk_widget_get_window ((GtkWidget*) _tmp10_);
		_tmp6_ = _tmp9_ == _tmp11_;
	} else {
		_tmp6_ = FALSE;
	}
	if (_tmp6_) {
		GtkAllocation child_alloc = {0};
		GtkPopover* _tmp12_;
		GtkAllocation _tmp13_ = {0};
		gboolean _tmp14_ = FALSE;
		gboolean _tmp15_ = FALSE;
		gboolean _tmp16_ = FALSE;
		GdkEventButton* _tmp17_;
		gdouble _tmp18_;
		GtkAllocation _tmp19_;
		gint _tmp20_;
		_tmp12_ = _data2_->popover;
		gtk_widget_get_allocation ((GtkWidget*) _tmp12_, &_tmp13_);
		child_alloc = _tmp13_;
		_tmp17_ = event;
		_tmp18_ = _tmp17_->x;
		_tmp19_ = child_alloc;
		_tmp20_ = _tmp19_.x;
		if (_tmp18_ < ((gdouble) _tmp20_)) {
			_tmp16_ = TRUE;
		} else {
			GdkEventButton* _tmp21_;
			gdouble _tmp22_;
			GtkAllocation _tmp23_;
			gint _tmp24_;
			GtkAllocation _tmp25_;
			gint _tmp26_;
			_tmp21_ = event;
			_tmp22_ = _tmp21_->x;
			_tmp23_ = child_alloc;
			_tmp24_ = _tmp23_.x;
			_tmp25_ = child_alloc;
			_tmp26_ = _tmp25_.width;
			_tmp16_ = _tmp22_ > ((gdouble) (_tmp24_ + _tmp26_));
		}
		if (_tmp16_) {
			_tmp15_ = TRUE;
		} else {
			GdkEventButton* _tmp27_;
			gdouble _tmp28_;
			GtkAllocation _tmp29_;
			gint _tmp30_;
			_tmp27_ = event;
			_tmp28_ = _tmp27_->y;
			_tmp29_ = child_alloc;
			_tmp30_ = _tmp29_.y;
			_tmp15_ = _tmp28_ < ((gdouble) _tmp30_);
		}
		if (_tmp15_) {
			_tmp14_ = TRUE;
		} else {
			GdkEventButton* _tmp31_;
			gdouble _tmp32_;
			GtkAllocation _tmp33_;
			gint _tmp34_;
			GtkAllocation _tmp35_;
			gint _tmp36_;
			_tmp31_ = event;
			_tmp32_ = _tmp31_->y;
			_tmp33_ = child_alloc;
			_tmp34_ = _tmp33_.y;
			_tmp35_ = child_alloc;
			_tmp36_ = _tmp35_.height;
			_tmp14_ = _tmp32_ > ((gdouble) (_tmp34_ + _tmp36_));
		}
		if (_tmp14_) {
			GtkPopover* _tmp37_;
			_tmp37_ = _data2_->popover;
			gtk_widget_hide ((GtkWidget*) _tmp37_);
			gtk_toggle_button_set_active ((GtkToggleButton*) self, FALSE);
		}
	} else {
		gboolean _tmp38_ = FALSE;
		GtkWidget* _tmp39_;
		_tmp39_ = event_widget;
		if (_tmp39_ != NULL) {
			GtkWidget* _tmp40_;
			GtkPopover* _tmp41_;
			gboolean _tmp42_;
			_tmp40_ = event_widget;
			_tmp41_ = _data2_->popover;
			_tmp42_ = gtk_widget_is_ancestor (_tmp40_, (GtkWidget*) _tmp41_);
			_tmp38_ = !_tmp42_;
		} else {
			_tmp38_ = FALSE;
		}
		if (_tmp38_) {
			GtkPopover* _tmp43_;
			_tmp43_ = _data2_->popover;
			gtk_widget_hide ((GtkWidget*) _tmp43_);
			gtk_toggle_button_set_active ((GtkToggleButton*) self, FALSE);
		}
	}
	result = TRUE;
	_g_object_unref0 (event_widget);
	_g_object_unref0 (child);
	return result;
}


static gboolean ___lambda8__gtk_widget_button_release_event (GtkWidget* _sender, GdkEventButton* event, gpointer self) {
	gboolean result;
	result = __lambda8_ (self, event);
	return result;
}


static void cert_button_on_tls_button_click (CertButton* self) {
	Block2Data* _data2_;
	GTlsCertificate* cert = NULL;
	GTlsCertificateFlags cert_flags = 0;
	gboolean _tmp0_;
	CaptiveLogin* _tmp1_;
	GTlsCertificate* _tmp2_ = NULL;
	GTlsCertificateFlags _tmp3_ = 0;
	gboolean _tmp4_;
	GtkPopover* _tmp5_;
	GtkPopover* _tmp6_;
	GIcon* button_icon = NULL;
	GtkWidget* _tmp7_;
	GIcon* _tmp8_ = NULL;
	GIcon* _tmp9_;
	GtkImage* icon = NULL;
	GIcon* _tmp10_;
	GtkImage* _tmp11_;
	GtkImage* _tmp12_;
	GtkLabel* primary_text = NULL;
	CaptiveLogin* _tmp13_;
	gchar* _tmp14_;
	gchar* _tmp15_;
	GtkLabel* _tmp16_;
	GtkLabel* _tmp17_;
	GtkLabel* _tmp18_;
	GtkStyleContext* _tmp19_;
	GtkLabel* _tmp20_;
	GtkLabel* _tmp21_;
	GtkLabel* _tmp22_;
	GtkLabel* _tmp23_;
	GtkLabel* _tmp24_;
	GtkLabel* secondary_text = NULL;
	gchar* _tmp25_;
	gchar* _tmp26_;
	GtkLabel* _tmp27_;
	GtkLabel* _tmp28_;
	GtkLabel* _tmp29_;
	GtkLabel* _tmp30_;
	CertButtonSecurity _tmp31_;
	CertButtonSecurity _tmp32_;
	GcrSimpleCertificate* gcr_cert = NULL;
	GTlsCertificate* _tmp41_;
	GByteArray* _tmp42_;
	GByteArray* _tmp43_;
	GByteArray* _tmp44_;
	guint8* _tmp45_;
	gint _tmp45__length1;
	GcrSimpleCertificate* _tmp46_;
	GcrSimpleCertificate* _tmp47_;
	GcrCertificateWidget* cert_details = NULL;
	GcrSimpleCertificate* _tmp48_;
	GcrCertificateWidget* _tmp49_;
	GtkGrid* grid = NULL;
	GtkGrid* _tmp50_;
	GtkGrid* _tmp51_;
	GtkGrid* _tmp52_;
	GtkImage* _tmp53_;
	GtkGrid* _tmp54_;
	GtkLabel* _tmp55_;
	GtkGrid* _tmp56_;
	GtkLabel* _tmp57_;
	GtkGrid* _tmp58_;
	GcrCertificateWidget* _tmp59_;
	GtkPopover* _tmp60_;
	GtkGrid* _tmp61_;
	GtkPopover* _tmp62_;
	GtkPopover* _tmp63_;
	GtkPopover* _tmp64_;
	g_return_if_fail (self != NULL);
	_data2_ = g_slice_new0 (Block2Data);
	_data2_->_ref_count_ = 1;
	_data2_->self = g_object_ref (self);
	_tmp0_ = gtk_toggle_button_get_active ((GtkToggleButton*) self);
	if (!_tmp0_) {
		_g_object_unref0 (cert);
		block2_data_unref (_data2_);
		_data2_ = NULL;
		return;
	}
	_tmp1_ = self->priv->_captive_login_window;
	_tmp4_ = captive_login_get_tls_info (_tmp1_, &_tmp2_, &_tmp3_);
	_g_object_unref0 (cert);
	cert = _tmp2_;
	cert_flags = _tmp3_;
	if (!_tmp4_) {
		gtk_toggle_button_set_active ((GtkToggleButton*) self, FALSE);
		_g_object_unref0 (cert);
		block2_data_unref (_data2_);
		_data2_ = NULL;
		return;
	}
	_tmp5_ = (GtkPopover*) gtk_popover_new ((GtkWidget*) self);
	g_object_ref_sink (_tmp5_);
	_data2_->popover = _tmp5_;
	_tmp6_ = _data2_->popover;
	gtk_container_set_border_width ((GtkContainer*) _tmp6_, (guint) 12);
	_tmp7_ = gtk_button_get_image ((GtkButton*) self);
	gtk_image_get_gicon (G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, gtk_image_get_type (), GtkImage), &_tmp8_, NULL);
	_g_object_unref0 (button_icon);
	_tmp9_ = _g_object_ref0 (_tmp8_);
	button_icon = _tmp9_;
	_tmp10_ = button_icon;
	_tmp11_ = (GtkImage*) gtk_image_new_from_gicon (_tmp10_, GTK_ICON_SIZE_DIALOG);
	g_object_ref_sink (_tmp11_);
	icon = _tmp11_;
	_tmp12_ = icon;
	gtk_widget_set_valign ((GtkWidget*) _tmp12_, GTK_ALIGN_START);
	_tmp13_ = self->priv->_captive_login_window;
	_tmp14_ = captive_login_get_uri (_tmp13_);
	_tmp15_ = _tmp14_;
	_tmp16_ = (GtkLabel*) gtk_label_new (_tmp15_);
	g_object_ref_sink (_tmp16_);
	_tmp17_ = _tmp16_;
	_g_free0 (_tmp15_);
	primary_text = _tmp17_;
	_tmp18_ = primary_text;
	_tmp19_ = gtk_widget_get_style_context ((GtkWidget*) _tmp18_);
	gtk_style_context_add_class (_tmp19_, "h3");
	_tmp20_ = primary_text;
	gtk_widget_set_halign ((GtkWidget*) _tmp20_, GTK_ALIGN_START);
	_tmp21_ = primary_text;
	gtk_widget_set_margin_start ((GtkWidget*) _tmp21_, 9);
	_tmp22_ = primary_text;
	gtk_label_set_max_width_chars (_tmp22_, 70);
	_tmp23_ = primary_text;
	g_object_set (_tmp23_, "wrap", TRUE, NULL);
	_tmp24_ = primary_text;
	g_object_set (_tmp24_, "wrap-mode", PANGO_WRAP_WORD_CHAR, NULL);
	_tmp25_ = gtk_widget_get_tooltip_text ((GtkWidget*) self);
	_tmp26_ = _tmp25_;
	_tmp27_ = (GtkLabel*) gtk_label_new (_tmp26_);
	g_object_ref_sink (_tmp27_);
	_tmp28_ = _tmp27_;
	_g_free0 (_tmp26_);
	secondary_text = _tmp28_;
	_tmp29_ = secondary_text;
	gtk_widget_set_halign ((GtkWidget*) _tmp29_, GTK_ALIGN_START);
	_tmp30_ = secondary_text;
	gtk_widget_set_margin_start ((GtkWidget*) _tmp30_, 9);
	_tmp31_ = cert_button_get_security (self);
	_tmp32_ = _tmp31_;
	if (_tmp32_ == CERT_BUTTON_SECURITY_SECURE) {
		GtkImage* _tmp33_;
		GtkStyleContext* _tmp34_;
		GtkLabel* _tmp35_;
		GtkStyleContext* _tmp36_;
		_tmp33_ = icon;
		_tmp34_ = gtk_widget_get_style_context ((GtkWidget*) _tmp33_);
		gtk_style_context_add_class (_tmp34_, "success");
		_tmp35_ = secondary_text;
		_tmp36_ = gtk_widget_get_style_context ((GtkWidget*) _tmp35_);
		gtk_style_context_add_class (_tmp36_, "success");
	} else {
		GtkImage* _tmp37_;
		GtkStyleContext* _tmp38_;
		GtkLabel* _tmp39_;
		GtkStyleContext* _tmp40_;
		_tmp37_ = icon;
		_tmp38_ = gtk_widget_get_style_context ((GtkWidget*) _tmp37_);
		gtk_style_context_add_class (_tmp38_, "warning");
		_tmp39_ = secondary_text;
		_tmp40_ = gtk_widget_get_style_context ((GtkWidget*) _tmp39_);
		gtk_style_context_add_class (_tmp40_, "warning");
	}
	_tmp41_ = cert;
	g_object_get (_tmp41_, "certificate", &_tmp42_, NULL);
	_tmp43_ = _tmp42_;
	_tmp44_ = _tmp43_;
	_tmp45_ = _tmp44_->data;
	_tmp45__length1 = (gint) _tmp44_->len;
	_tmp46_ = (GcrSimpleCertificate*) gcr_simple_certificate_new (_tmp45_, _tmp45__length1);
	_tmp47_ = _tmp46_;
	_g_byte_array_unref0 (_tmp44_);
	gcr_cert = _tmp47_;
	_tmp48_ = gcr_cert;
	_tmp49_ = gcr_certificate_widget_new ((GcrCertificate*) _tmp48_);
	g_object_ref_sink (_tmp49_);
	cert_details = _tmp49_;
	_tmp50_ = (GtkGrid*) gtk_grid_new ();
	g_object_ref_sink (_tmp50_);
	grid = _tmp50_;
	_tmp51_ = grid;
	gtk_grid_set_column_spacing (_tmp51_, 3);
	_tmp52_ = grid;
	_tmp53_ = icon;
	gtk_grid_attach (_tmp52_, (GtkWidget*) _tmp53_, 0, 0, 1, 2);
	_tmp54_ = grid;
	_tmp55_ = primary_text;
	gtk_grid_attach (_tmp54_, (GtkWidget*) _tmp55_, 1, 0, 1, 1);
	_tmp56_ = grid;
	_tmp57_ = secondary_text;
	gtk_grid_attach (_tmp56_, (GtkWidget*) _tmp57_, 1, 1, 1, 1);
	_tmp58_ = grid;
	_tmp59_ = cert_details;
	gtk_grid_attach (_tmp58_, (GtkWidget*) _tmp59_, 1, 2, 1, 1);
	_tmp60_ = _data2_->popover;
	_tmp61_ = grid;
	gtk_container_add ((GtkContainer*) _tmp60_, (GtkWidget*) _tmp61_);
	_tmp62_ = _data2_->popover;
	g_signal_connect_object ((GtkWidget*) _tmp62_, "button-press-event", (GCallback) ___lambda7__gtk_widget_button_press_event, self, 0);
	_tmp63_ = _data2_->popover;
	g_signal_connect_data ((GtkWidget*) _tmp63_, "button-release-event", (GCallback) ___lambda8__gtk_widget_button_release_event, block2_data_ref (_data2_), (GClosureNotify) block2_data_unref, 0);
	_tmp64_ = _data2_->popover;
	gtk_widget_show_all ((GtkWidget*) _tmp64_);
	_g_object_unref0 (grid);
	_g_object_unref0 (cert_details);
	_g_object_unref0 (gcr_cert);
	_g_object_unref0 (secondary_text);
	_g_object_unref0 (primary_text);
	_g_object_unref0 (icon);
	_g_object_unref0 (button_icon);
	_g_object_unref0 (cert);
	block2_data_unref (_data2_);
	_data2_ = NULL;
	return;
}


CertButtonSecurity cert_button_get_security (CertButton* self) {
	CertButtonSecurity result;
	CertButtonSecurity _tmp0_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_security;
	result = _tmp0_;
	return result;
}


void cert_button_set_security (CertButton* self, CertButtonSecurity value) {
	CertButtonSecurity _tmp0_;
	GIcon* icon = NULL;
	gchar* tooltip = NULL;
	CertButtonSecurity _tmp1_;
	GIcon* _tmp10_;
	GtkImage* _tmp11_;
	GtkImage* _tmp12_;
	const gchar* _tmp13_;
	gboolean _tmp14_ = FALSE;
	CertButtonSecurity _tmp15_;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	self->priv->_security = _tmp0_;
	_tmp1_ = value;
	switch (_tmp1_) {
		case CERT_BUTTON_SECURITY_LOADING:
		{
			GThemedIcon* _tmp2_;
			gchar* _tmp3_;
			_tmp2_ = (GThemedIcon*) g_themed_icon_new ("content-loading-symbolic");
			_g_object_unref0 (icon);
			icon = (GIcon*) _tmp2_;
			_tmp3_ = g_strdup (_ ("Loading captive portal."));
			_g_free0 (tooltip);
			tooltip = _tmp3_;
			break;
		}
		case CERT_BUTTON_SECURITY_NONE:
		{
			GThemedIcon* _tmp4_;
			gchar* _tmp5_;
			_tmp4_ = (GThemedIcon*) g_themed_icon_new ("security-low-symbolic");
			_g_object_unref0 (icon);
			icon = (GIcon*) _tmp4_;
			_tmp5_ = g_strdup (_ ("The page is served over an unprotected connection."));
			_g_free0 (tooltip);
			tooltip = _tmp5_;
			break;
		}
		case CERT_BUTTON_SECURITY_SECURE:
		{
			GThemedIcon* _tmp6_;
			gchar* _tmp7_;
			_tmp6_ = (GThemedIcon*) g_themed_icon_new ("security-high-symbolic");
			_g_object_unref0 (icon);
			icon = (GIcon*) _tmp6_;
			_tmp7_ = g_strdup (_ ("The page is served over a protected connection."));
			_g_free0 (tooltip);
			tooltip = _tmp7_;
			break;
		}
		case CERT_BUTTON_SECURITY_MIXED_CONTENT:
		{
			GThemedIcon* _tmp8_;
			gchar* _tmp9_;
			_tmp8_ = (GThemedIcon*) g_themed_icon_new ("security-medium-symbolic");
			_g_object_unref0 (icon);
			icon = (GIcon*) _tmp8_;
			_tmp9_ = g_strdup (_ ("Some elements of this page are served over an unprotected connection."));
			_g_free0 (tooltip);
			tooltip = _tmp9_;
			break;
		}
		default:
		{
			g_assert_not_reached ();
		}
	}
	_tmp10_ = icon;
	_tmp11_ = (GtkImage*) gtk_image_new_from_gicon (_tmp10_, GTK_ICON_SIZE_BUTTON);
	g_object_ref_sink (_tmp11_);
	_tmp12_ = _tmp11_;
	gtk_button_set_image ((GtkButton*) self, (GtkWidget*) _tmp12_);
	_g_object_unref0 (_tmp12_);
	_tmp13_ = tooltip;
	gtk_widget_set_tooltip_text ((GtkWidget*) self, _tmp13_);
	_tmp15_ = value;
	if (_tmp15_ != CERT_BUTTON_SECURITY_NONE) {
		CertButtonSecurity _tmp16_;
		_tmp16_ = value;
		_tmp14_ = _tmp16_ != CERT_BUTTON_SECURITY_LOADING;
	} else {
		_tmp14_ = FALSE;
	}
	gtk_widget_set_sensitive ((GtkWidget*) self, _tmp14_);
	_g_free0 (tooltip);
	_g_object_unref0 (icon);
	g_object_notify_by_pspec ((GObject *) self, cert_button_properties[CERT_BUTTON_SECURITY_PROPERTY]);
}


CaptiveLogin* cert_button_get_captive_login_window (CertButton* self) {
	CaptiveLogin* result;
	CaptiveLogin* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_captive_login_window;
	result = _tmp0_;
	return result;
}


void cert_button_set_captive_login_window (CertButton* self, CaptiveLogin* value) {
	g_return_if_fail (self != NULL);
	if (cert_button_get_captive_login_window (self) != value) {
		CaptiveLogin* _tmp0_;
		CaptiveLogin* _tmp1_;
		_tmp0_ = value;
		_tmp1_ = _g_object_ref0 (_tmp0_);
		_g_object_unref0 (self->priv->_captive_login_window);
		self->priv->_captive_login_window = _tmp1_;
		g_object_notify_by_pspec ((GObject *) self, cert_button_properties[CERT_BUTTON_CAPTIVE_LOGIN_WINDOW_PROPERTY]);
	}
}


static void _cert_button_on_tls_button_click_gtk_toggle_button_toggled (GtkToggleButton* _sender, gpointer self) {
	cert_button_on_tls_button_click ((CertButton*) self);
}


static GObject * cert_button_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties) {
	GObject * obj;
	GObjectClass * parent_class;
	CertButton * self;
	GtkStyleContext* style_context = NULL;
	GtkStyleContext* _tmp0_;
	GtkStyleContext* _tmp1_;
	GtkStyleContext* _tmp2_;
	GtkStyleContext* _tmp3_;
	parent_class = G_OBJECT_CLASS (cert_button_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_CERT_BUTTON, CertButton);
	_tmp0_ = gtk_widget_get_style_context ((GtkWidget*) self);
	_tmp1_ = _g_object_ref0 (_tmp0_);
	style_context = _tmp1_;
	_tmp2_ = style_context;
	gtk_style_context_add_class (_tmp2_, GTK_STYLE_CLASS_FLAT);
	_tmp3_ = style_context;
	gtk_style_context_add_class (_tmp3_, "titlebutton");
	g_signal_connect_object ((GtkToggleButton*) self, "toggled", (GCallback) _cert_button_on_tls_button_click_gtk_toggle_button_toggled, self, 0);
	_g_object_unref0 (style_context);
	return obj;
}


static void cert_button_class_init (CertButtonClass * klass) {
	cert_button_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (CertButtonPrivate));
	G_OBJECT_CLASS (klass)->get_property = _vala_cert_button_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_cert_button_set_property;
	G_OBJECT_CLASS (klass)->constructor = cert_button_constructor;
	G_OBJECT_CLASS (klass)->finalize = cert_button_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), CERT_BUTTON_SECURITY_PROPERTY, cert_button_properties[CERT_BUTTON_SECURITY_PROPERTY] = g_param_spec_enum ("security", "security", "security", CERT_BUTTON_TYPE_SECURITY, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), CERT_BUTTON_CAPTIVE_LOGIN_WINDOW_PROPERTY, cert_button_properties[CERT_BUTTON_CAPTIVE_LOGIN_WINDOW_PROPERTY] = g_param_spec_object ("captive-login-window", "captive-login-window", "captive-login-window", TYPE_CAPTIVE_LOGIN, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
}


static void cert_button_instance_init (CertButton * self) {
	self->priv = CERT_BUTTON_GET_PRIVATE (self);
}


static void cert_button_finalize (GObject * obj) {
	CertButton * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_CERT_BUTTON, CertButton);
	_g_object_unref0 (self->priv->_captive_login_window);
	G_OBJECT_CLASS (cert_button_parent_class)->finalize (obj);
}


GType cert_button_get_type (void) {
	static volatile gsize cert_button_type_id__volatile = 0;
	if (g_once_init_enter (&cert_button_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (CertButtonClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) cert_button_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (CertButton), 0, (GInstanceInitFunc) cert_button_instance_init, NULL };
		GType cert_button_type_id;
		cert_button_type_id = g_type_register_static (gtk_toggle_button_get_type (), "CertButton", &g_define_type_info, 0);
		g_once_init_leave (&cert_button_type_id__volatile, cert_button_type_id);
	}
	return cert_button_type_id__volatile;
}


static void _vala_cert_button_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	CertButton * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_CERT_BUTTON, CertButton);
	switch (property_id) {
		case CERT_BUTTON_SECURITY_PROPERTY:
		g_value_set_enum (value, cert_button_get_security (self));
		break;
		case CERT_BUTTON_CAPTIVE_LOGIN_WINDOW_PROPERTY:
		g_value_set_object (value, cert_button_get_captive_login_window (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_cert_button_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	CertButton * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_CERT_BUTTON, CertButton);
	switch (property_id) {
		case CERT_BUTTON_SECURITY_PROPERTY:
		cert_button_set_security (self, g_value_get_enum (value));
		break;
		case CERT_BUTTON_CAPTIVE_LOGIN_WINDOW_PROPERTY:
		cert_button_set_captive_login_window (self, g_value_get_object (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}



